/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  mkdb.Mkdb
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  xbean.EventInfo
 *  xbean.OnetimeEvent
 *  xbean.Pod
 *  xtable.Onetimeeventtab
 *  xtable.Worldeventtab
 */
package fire.pb;

import fire.pb.WorldTime;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicLong;
import mkdb.Mkdb;
import mkdb.Procedure;
import mkdb.Transaction;
import xbean.EventInfo;
import xbean.OnetimeEvent;
import xbean.Pod;
import xtable.Onetimeeventtab;
import xtable.Worldeventtab;

public class WorldEventTab
implements Runnable {
    private static WorldEventTab instance;
    private AtomicLong eventidx = new AtomicLong(0L);
    private Set<Long> running = new HashSet<Long>();
    private Set<Long> onetimerunning = new HashSet<Long>();
    private AtomicBoolean walking = new AtomicBoolean(false);

    public static WorldEventTab getInstance() {
        return instance;
    }

    public WorldEventTab() {
        if (instance == null) {
            instance = this;
        }
    }

    public void start() {
        WorldTime now = WorldTime.getInstance();
        Mkdb.executor().scheduleAtFixedRate((Runnable)this, (long)(60 - now.get(13)), 60L, TimeUnit.SECONDS);
    }

    public long add(final CronTask task, final String schedule) {
        Procedure p = new Procedure(){

            /*
             * WARNING - Removed try catching itself - possible behaviour change.
             */
            protected boolean process() {
                EventInfo ei = Pod.newEventInfo();
                ei.setEvent(new CrontabTask(task, schedule));
                long key = WorldEventTab.this.eventidx.incrementAndGet();
                while (key == 0L || key == -1L) {
                    key = WorldEventTab.this.eventidx.incrementAndGet();
                }
                Worldeventtab.insert((Long)key, (EventInfo)ei);
                Set set = WorldEventTab.this.running;
                synchronized (set) {
                    WorldEventTab.this.running.add(key);
                }
                return true;
            }
        };
        if (Transaction.current() == null) {
            p.submit();
            return -1L;
        }
        if (p.call()) {
            return this.eventidx.get();
        }
        return 0L;
    }

    public long addDelay(final CronTask task, final int delay) {
        Procedure p = new Procedure(){

            /*
             * WARNING - Removed try catching itself - possible behaviour change.
             */
            protected boolean process() {
                OnetimeEvent oe = Pod.newOnetimeEvent();
                oe.setOnetimeevent(new OnetimeTask(task, delay));
                long key = WorldEventTab.this.eventidx.incrementAndGet();
                while (key == 0L || key == -1L) {
                    key = WorldEventTab.this.eventidx.incrementAndGet();
                }
                Onetimeeventtab.insert((Long)key, (OnetimeEvent)oe);
                Set set = WorldEventTab.this.onetimerunning;
                synchronized (set) {
                    WorldEventTab.this.onetimerunning.add(key);
                }
                return true;
            }
        };
        if (Transaction.current() == null) {
            p.submit();
            return -1L;
        }
        if (p.call()) {
            return this.eventidx.get();
        }
        return 0L;
    }

    public void remove(final long idx) {
        if (this.walking.get()) {
            return;
        }
        Procedure p = new Procedure(){

            /*
             * WARNING - Removed try catching itself - possible behaviour change.
             */
            protected boolean process() {
                if (Worldeventtab.remove((Long)idx)) {
                    Set set = WorldEventTab.this.running;
                    synchronized (set) {
                        WorldEventTab.this.running.remove(idx);
                    }
                    return true;
                }
                if (Onetimeeventtab.remove((Long)idx)) {
                    Set set = WorldEventTab.this.onetimerunning;
                    synchronized (set) {
                        WorldEventTab.this.onetimerunning.remove(idx);
                    }
                    return true;
                }
                return false;
            }
        };
        if (Transaction.current() == null) {
            p.submit();
        } else {
            p.call();
        }
    }

    @Override
    public final void run() {
        final WorldTime now = WorldTime.getInstance();
        new Procedure(){

            /*
             * WARNING - Removed try catching itself - possible behaviour change.
             */
            protected boolean process() {
                Object object = WorldEventTab.this.running.iterator();
                while (object.hasNext()) {
                    long run = (Long)object.next();
                    EventInfo ei = Worldeventtab.get((Long)run);
                    if (ei == null || !ei.getEvent().match(now)) continue;
                    ei.getEvent().run();
                }
                object = WorldEventTab.this.onetimerunning;
                synchronized (object) {
                    WorldEventTab.this.walking.set(true);
                    try {
                        Iterator iter = WorldEventTab.this.onetimerunning.iterator();
                        while (iter.hasNext()) {
                            long run = (Long)iter.next();
                            OnetimeEvent oe = Onetimeeventtab.get((Long)run);
                            if (oe == null || !oe.getOnetimeevent().match(now)) continue;
                            oe.getOnetimeevent().run();
                            iter.remove();
                            Onetimeeventtab.remove((Long)run);
                        }
                    }
                    catch (Throwable throwable) {
                    }
                    finally {
                        WorldEventTab.this.walking.set(false);
                    }
                }
                return true;
            }
        }.submit();
    }

    public CronTask getTask(long eventidx) {
        EventInfo ei = Worldeventtab.get((Long)eventidx);
        if (ei != null) {
            return ei.getEvent().task;
        }
        OnetimeEvent oe = Onetimeeventtab.get((Long)eventidx);
        if (oe != null) {
            return oe.getOnetimeevent().task;
        }
        return null;
    }

    public static interface CronTask {
        public void run();
    }

    public static class OnetimeTask {
        private final WorldTime runtime;
        private final CronTask task;

        OnetimeTask(CronTask task, int delay) {
            this.task = task;
            this.runtime = WorldTime.getInstance();
            this.runtime.add(12, delay);
        }

        public void run() {
            this.task.run();
        }

        public boolean match(WorldTime now) {
            return now.after(this.runtime);
        }
    }

    public static class CrontabTask {
        CronTask task;
        Set<Integer> minutes = new HashSet<Integer>();
        Set<Integer> hours = new HashSet<Integer>();
        Set<Integer> days = new HashSet<Integer>();
        Set<Integer> months = new HashSet<Integer>();
        Set<Integer> weekdays = new HashSet<Integer>();

        CrontabTask(CronTask task, String schedule) {
            this.task = task;
            String[] schedulestrings = schedule.split("\\s+");
            if (schedulestrings.length == 5) {
                if (!this.init(this.minutes, schedulestrings[0], 0, 59)) {
                    throw new IllegalArgumentException("错误的定时任务配置");
                }
                if (!this.init(this.hours, schedulestrings[1], 0, 23)) {
                    throw new IllegalArgumentException("错误的定时任务配置");
                }
                if (!this.init(this.days, schedulestrings[2], 1, 31)) {
                    throw new IllegalArgumentException("错误的定时任务配置");
                }
                if (!this.init(this.months, schedulestrings[3], 1, 12)) {
                    throw new IllegalArgumentException("错误的定时任务配置");
                }
                if (!this.init(this.weekdays, schedulestrings[4], 1, 7)) {
                    throw new IllegalArgumentException("错误的定时任务配置");
                }
            } else {
                throw new IllegalArgumentException("错误的定时任务配置");
            }
        }

        void run() {
            this.task.run();
        }

        boolean match(WorldTime time) {
            if (!this.match(time, time.get(12), this.minutes)) {
                return false;
            }
            if (!this.match(time, time.get(11), this.hours)) {
                return false;
            }
            if (!this.match(time, time.get(5), this.months)) {
                return false;
            }
            if (!this.match(time, time.get(2) + 1, this.months)) {
                return false;
            }
            return this.match(time, time.get(7), this.weekdays);
        }

        private boolean match(WorldTime time, int curval, Set<Integer> requires) {
            return requires.isEmpty() || requires.contains(curval);
        }

        private boolean init(Set<Integer> ret, String string, int min, int max) {
            for (String substring : string.split(",")) {
                if (substring.matches("\\d+")) {
                    ret.add(Integer.parseInt(substring));
                    continue;
                }
                if (substring.matches("\\d+-\\d+")) {
                    int i;
                    int b;
                    int idx = substring.indexOf("-");
                    int a = Integer.parseInt(substring.substring(0, idx));
                    if (a >= (b = Integer.parseInt(substring.substring(idx + 1, substring.length())))) {
                        if (b < min || a > max) {
                            return false;
                        }
                        for (i = b; i <= a; ++i) {
                            ret.add(i);
                        }
                        continue;
                    }
                    if (a < min || b > max) {
                        return false;
                    }
                    for (i = a; i <= b; ++i) {
                        ret.add(i);
                    }
                    continue;
                }
                if (substring.matches("\\*")) continue;
                return false;
            }
            return true;
        }
    }
}

